Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/C14/trcsms_c14.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/C14/trcsms_c14.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/C14/trcsms_c14.F90	(revision 12928)
@@ -26,4 +26,6 @@
    PUBLIC   trc_sms_c14       ! called in trcsms.F90
 
+   !! * Substitutions
+#  include "do_loop_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/TOP 4.0 , NEMO Consortium (2018)
@@ -33,5 +35,5 @@
 CONTAINS
 
-   SUBROUTINE trc_sms_c14( kt )
+   SUBROUTINE trc_sms_c14( kt, Kbb, Kmm, Krhs )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE trc_sms_c14  ***
@@ -46,11 +48,12 @@
       !            freshwater fluxes which should not impact the C14/C ratio
       !
-      !        =>   Delta-C14= ( trn(...jp_c14) -1)*1000.
+      !        =>   Delta-C14= ( tr(...jp_c14,Kmm) -1)*1000.
       !!
       !!----------------------------------------------------------------------
       !
-      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      INTEGER, INTENT(in) ::   kt               ! ocean time-step index
+      INTEGER, INTENT(in) ::   Kbb, Kmm, Krhs   ! ocean time level
       !
-      INTEGER  :: ji, jj, jk         ! dummy loop indices 
+      INTEGER  :: ji, jj, jk        ! dummy loop indices 
       REAL(wp) :: zt, ztp, zsk      ! dummy variables
       REAL(wp) :: zsol              ! solubility
@@ -77,40 +80,38 @@
       ! -------------------------------------------------------------------
 
-      DO jj = 1, jpj
-         DO ji = 1, jpi  
-            IF( tmask(ji,jj,1) >  0. ) THEN
-               !
-               zt   = MIN( 40. , tsn(ji,jj,1,jp_tem) )
-               !
-               !  Computation of solubility zsol in [mol/(L * atm)]
-               !   after Wanninkhof (2014) referencing Weiss (1974)
-               ztp  = ( zt + 273.16 ) * 0.01
-               zsk  = 0.027766 + ztp * ( -0.025888 + 0.0050578 * ztp )   ! [mol/(L * atm)]
-               zsol = EXP( -58.0931 + 90.5069 / ztp  + 22.2940 * LOG( ztp ) + zsk * tsn(ji,jj,1,jp_sal) )
-               ! convert solubilities [mol/(L * atm)] -> [mol/(m^3 * ppm)]
-               zsol = zsol * 1.e-03
+      DO_2D_11_11
+         IF( tmask(ji,jj,1) >  0. ) THEN
+            !
+            zt   = MIN( 40. , ts(ji,jj,1,jp_tem,Kmm) )
+            !
+            !  Computation of solubility zsol in [mol/(L * atm)]
+            !   after Wanninkhof (2014) referencing Weiss (1974)
+            ztp  = ( zt + 273.16 ) * 0.01
+            zsk  = 0.027766 + ztp * ( -0.025888 + 0.0050578 * ztp )   ! [mol/(L * atm)]
+            zsol = EXP( -58.0931 + 90.5069 / ztp  + 22.2940 * LOG( ztp ) + zsk * ts(ji,jj,1,jp_sal,Kmm) )
+            ! convert solubilities [mol/(L * atm)] -> [mol/(m^3 * ppm)]
+            zsol = zsol * 1.e-03
 
-               ! Computes the Schmidt number of CO2 in seawater
-               !               Wanninkhof-2014
-               zsch = 2116.8 + zt * ( -136.25 + zt * (4.7353 + zt * (-0.092307 + 0.0007555 * zt ) ) )
+            ! Computes the Schmidt number of CO2 in seawater
+            !               Wanninkhof-2014
+            zsch = 2116.8 + zt * ( -136.25 + zt * (4.7353 + zt * (-0.092307 + 0.0007555 * zt ) ) )
 
-               ! Wanninkhof Piston velocity: zpv in units [m/s]
-               zv2 = xkwind * (wndm(ji,jj) * wndm(ji,jj))              ! wind speed module at T points
-               ! chemical enhancement (Wanninkhof & Knox, 1996)
-               IF( ln_chemh ) zv2 = zv2 + 2.5 * ( 0.5246 + zt * (0.016256 + 0.00049946  * zt ) )
-               zv2 = zv2/360000._wp                                    ! conversion cm/h -> m/s
-               !
-               zpv  = ( zv2 * SQRT( 660./ zsch ) ) * ( 1. - fr_i(ji,jj) ) * tmask(ji,jj,1)
+            ! Wanninkhof Piston velocity: zpv in units [m/s]
+            zv2 = xkwind * (wndm(ji,jj) * wndm(ji,jj))              ! wind speed module at T points
+            ! chemical enhancement (Wanninkhof & Knox, 1996)
+            IF( ln_chemh ) zv2 = zv2 + 2.5 * ( 0.5246 + zt * (0.016256 + 0.00049946  * zt ) )
+            zv2 = zv2/360000._wp                                    ! conversion cm/h -> m/s
+            !
+            zpv  = ( zv2 * SQRT( 660./ zsch ) ) * ( 1. - fr_i(ji,jj) ) * tmask(ji,jj,1)
 
-               ! CO2 piston velocity (m/s)
-               exch_co2(ji,jj)= zpv
-               ! CO2 invasion rate (mol/ppm/m2/s) = 1st part of 14C/C exchange velocity
-               exch_c14(ji,jj)= zpv * zsol
-            ELSE
-               exch_co2(ji,jj) = 0._wp
-               exch_c14(ji,jj) = 0._wp
-            ENDIF
-         END DO
-      END DO
+            ! CO2 piston velocity (m/s)
+            exch_co2(ji,jj)= zpv
+            ! CO2 invasion rate (mol/ppm/m2/s) = 1st part of 14C/C exchange velocity
+            exch_c14(ji,jj)= zpv * zsol
+         ELSE
+            exch_co2(ji,jj) = 0._wp
+            exch_c14(ji,jj) = 0._wp
+         ENDIF
+      END_2D
 
       ! Exchange velocity for 14C/C ratio (m/s)
@@ -120,26 +121,20 @@
       ! Flux of C-14 from air-to-sea; units: (C14/C ratio) x m/s
       !                               already masked
-      qtr_c14(:,:) = exch_c14(:,:) * ( c14sbc(:,:) - trb(:,:,1,jp_c14) )
+      qtr_c14(:,:) = exch_c14(:,:) * ( c14sbc(:,:) - tr(:,:,1,jp_c14,Kbb) )
             
       ! cumulation of air-to-sea flux at each time step
-      qint_c14(:,:) = qint_c14(:,:) + qtr_c14(:,:) * rdttrc
+      qint_c14(:,:) = qint_c14(:,:) + qtr_c14(:,:) * rn_Dt
       !
       ! Add the surface flux to the trend of jp_c14
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            tra(ji,jj,1,jp_c14) = tra(ji,jj,1,jp_c14) + qtr_c14(ji,jj) / e3t_n(ji,jj,1) 
-         END DO
-      END DO
+      DO_2D_11_11
+         tr(ji,jj,1,jp_c14,Krhs) = tr(ji,jj,1,jp_c14,Krhs) + qtr_c14(ji,jj) / e3t(ji,jj,1,Kmm) 
+      END_2D
       !
       ! Computation of decay effects on jp_c14
-      DO jk = 1, jpk
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               !
-               tra(ji,jj,jk,jp_c14) = tra(ji,jj,jk,jp_c14) - rlam14 * trb(ji,jj,jk,jp_c14) * tmask(ji,jj,jk) 
-               !
-            END DO
-         END DO
-      END DO
+      DO_3D_11_11( 1, jpk )
+         !
+         tr(ji,jj,jk,jp_c14,Krhs) = tr(ji,jj,jk,jp_c14,Krhs) - rlam14 * tr(ji,jj,jk,jp_c14,Kbb) * tmask(ji,jj,jk) 
+         !
+      END_3D
       !
       IF( lrst_trc ) THEN
@@ -157,5 +152,5 @@
       ENDIF
 
-      IF( l_trdtrc )  CALL trd_trc( tra(:,:,:,jp_c14), 1, jptra_sms, kt )   ! save trends
+      IF( l_trdtrc )  CALL trd_trc( tr(:,:,:,jp_c14,Krhs), 1, jptra_sms, kt, Kmm )   ! save trends
       !
       IF( ln_timing )   CALL timing_stop('trc_sms_c14')
Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/C14/trcwri_c14.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/C14/trcwri_c14.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/C14/trcwri_c14.F90	(revision 12928)
@@ -23,9 +23,11 @@
    !   Standard ratio: 1.176E-12 ; Avogadro's nbr = 6.022E+23 at/mol ; bomb C14 traditionally reported as 1.E+26 atoms
    REAL(wp), PARAMETER  :: atomc14 = 1.176 * 6.022E-15   ! conversion factor 
+   !! * Substitutions
+#  include "do_loop_substitute.h90"
 
 
 CONTAINS
 
-   SUBROUTINE trc_wri_c14
+   SUBROUTINE trc_wri_c14( Kmm )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE trc_wri_c14  ***
@@ -33,4 +35,5 @@
       !! ** Purpose :   output additional C14 tracers fields 
       !!---------------------------------------------------------------------
+      INTEGER, INTENT(in)  :: Kmm           ! time level indices
       CHARACTER (len=20)   :: cltra         ! short title for tracer
       INTEGER              :: ji,jj,jk,jn   ! dummy loop indexes
@@ -43,5 +46,5 @@
       ! ---------------------------------------
       cltra = TRIM( ctrcnm(jp_c14) )                  ! short title for tracer
-      CALL iom_put( cltra, trn(:,:,:,jp_c14) )
+      CALL iom_put( cltra, tr(:,:,:,jp_c14,Kmm) )
 
       ! compute and write the tracer diagnostic in the file
@@ -57,14 +60,10 @@
          zz3d(:,:,:) = 0._wp
          !
-         DO jk = 1, jpkm1
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  IF( tmask(ji,jj,jk) > 0._wp) THEN
-                     z3d (ji,jj,jk) = trn(ji,jj,jk,jp_c14)
-                     zz3d(ji,jj,jk) = LOG( z3d(ji,jj,jk) )
-                  ENDIF
-               ENDDO
-            ENDDO
-         ENDDO
+         DO_3D_11_11( 1, jpkm1 )
+            IF( tmask(ji,jj,jk) > 0._wp) THEN
+               z3d (ji,jj,jk) = tr(ji,jj,jk,jp_c14,Kmm)
+               zz3d(ji,jj,jk) = LOG( z3d(ji,jj,jk) )
+            ENDIF
+         END_3D
          zres(:,:) = z3d(:,:,1)
 
@@ -72,10 +71,8 @@
          z2d(:,:) =0._wp
          jk = 1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               ztemp = zres(ji,jj) / c14sbc(ji,jj)
-               IF( ztemp > 0._wp .AND. tmask(ji,jj,jk) > 0._wp ) z2d(ji,jj) = LOG( ztemp )
-            ENDDO
-         ENDDO
+         DO_2D_11_11
+            ztemp = zres(ji,jj) / c14sbc(ji,jj)
+            IF( ztemp > 0._wp .AND. tmask(ji,jj,jk) > 0._wp ) z2d(ji,jj) = LOG( ztemp )
+         END_2D
          !
          z3d(:,:,:) = 1.d03 * ( z3d(:,:,:) - 1._wp )
@@ -113,5 +110,5 @@
       ENDIF
       IF( iom_use("C14Inv") ) THEN
-         ztemp = glob_sum( 'trcwri_c14', trn(:,:,:,jp_c14) * cvol(:,:,:) )
+         ztemp = glob_sum( 'trcwri_c14', tr(:,:,:,jp_c14,Kmm) * cvol(:,:,:) )
          ztemp = atomc14 * xdicsur * ztemp
          CALL iom_put( "C14Inv", ztemp )  !  Radiocarbon ocean inventory [10^26 atoms]
@@ -130,4 +127,6 @@
 #endif
 
+   !! * Substitutions
+#  include "do_loop_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/TOP 4.0 , NEMO Consortium (2018)
Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcini_cfc.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcini_cfc.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcini_cfc.F90	(revision 12928)
@@ -24,4 +24,6 @@
    REAL(wp) ::   ylatn =  10.           ! 10 degrees north
 
+   !! * Substitutions
+#  include "do_loop_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/TOP 4.0 , NEMO Consortium (2018)
@@ -31,5 +33,5 @@
 CONTAINS
 
-   SUBROUTINE trc_ini_cfc
+   SUBROUTINE trc_ini_cfc( Kmm )
       !!----------------------------------------------------------------------
       !!                     ***  trc_ini_cfc  ***  
@@ -39,6 +41,7 @@
       !! ** Method  : - Read the namcfc namelist and check the parameter values
       !!----------------------------------------------------------------------
+      INTEGER, INTENT(in)  ::  Kmm  ! time level indices
       INTEGER  ::  ji, jj, jn, jl, jm, js, io, ierr
-      INTEGER  ::  iskip = 6   ! number of 1st descriptor lines
+      INTEGER  ::  iskip = 6        ! number of 1st descriptor lines
       REAL(wp) ::  zyy, zyd
       CHARACTER(len = 20)  ::  cltra
@@ -90,5 +93,5 @@
          DO jl = 1, jp_cfc
             jn = jp_cfc0 + jl - 1
-            trn(:,:,:,jn) = 0._wp
+            tr(:,:,:,jn,Kmm) = 0._wp
          END DO
       ENDIF
@@ -129,12 +132,10 @@
       !---------------------------------------------------------------------------------------
       zyd = ylatn - ylats      
-      DO jj = 1 , jpj
-         DO ji = 1 , jpi
-            IF(     gphit(ji,jj) >= ylatn ) THEN   ;   xphem(ji,jj) = 1.e0
-            ELSEIF( gphit(ji,jj) <= ylats ) THEN   ;   xphem(ji,jj) = 0.e0
-            ELSE                                   ;   xphem(ji,jj) = ( gphit(ji,jj) - ylats) / zyd
-            ENDIF
-         END DO
-      END DO
+      DO_2D_11_11
+         IF(     gphit(ji,jj) >= ylatn ) THEN   ;   xphem(ji,jj) = 1.e0
+         ELSEIF( gphit(ji,jj) <= ylats ) THEN   ;   xphem(ji,jj) = 0.e0
+         ELSE                                   ;   xphem(ji,jj) = ( gphit(ji,jj) - ylats) / zyd
+         ENDIF
+      END_2D
       !
       IF(lwp) WRITE(numout,*) 'Initialization of CFC tracers done'
Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcnam_cfc.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcnam_cfc.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcnam_cfc.F90	(revision 12928)
@@ -51,8 +51,6 @@
       ENDIF
       !
-      REWIND( numtrc_ref )              ! Namelist namcfcdate in reference namelist : CFC parameters
       READ  ( numtrc_ref, namcfc, IOSTAT = ios, ERR = 901)
 901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namcfc in reference namelist' )
-      REWIND( numtrc_cfg )              ! Namelist namcfcdate in configuration namelist : CFC parameters
       READ  ( numtrc_cfg, namcfc, IOSTAT = ios, ERR = 902 )
 902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namcfc in configuration namelist' )
Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcsms_cfc.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcsms_cfc.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcsms_cfc.F90	(revision 12928)
@@ -47,4 +47,6 @@
    REAL(wp) ::   xconv4 = 1.0e-12      ! conversion from mol/m3/atm to mol/m3/pptv 
 
+   !! * Substitutions
+#  include "do_loop_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/TOP 4.0 , NEMO Consortium (2018)
@@ -54,5 +56,5 @@
 CONTAINS
 
-   SUBROUTINE trc_sms_cfc( kt )
+   SUBROUTINE trc_sms_cfc( kt, Kbb, Kmm, Krhs )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE trc_sms_cfc  ***
@@ -70,5 +72,6 @@
       !!                CFC concentration in pico-mol/m3
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      INTEGER, INTENT(in) ::   kt               ! ocean time-step index
+      INTEGER, INTENT(in) ::   Kbb, Kmm, Krhs   ! ocean time level
       !
       INTEGER  ::   ji, jj, jn, jl, jm
@@ -105,4 +108,8 @@
          im2       =      nmonth - 7
       ENDIF
+      ! Avoid bad interpolation if starting date is =< 1900
+      IF( iyear_beg .LE. 0      )  iyear_beg = 1
+      IF( iyear_beg .GE. jpyear )  iyear_beg = jpyear - 1
+      !
       iyear_end = iyear_beg + 1
 
@@ -118,51 +125,48 @@
          
          !                                                         !------------!
-         DO jj = 1, jpj                                            !  i-j loop  !
-            DO ji = 1, jpi                                         !------------!
+         DO_2D_11_11
  
-               ! space interpolation
-               zpp_cfc  =       xphem(ji,jj)   * zpatm(1,jl)   &
-                  &     + ( 1.- xphem(ji,jj) ) * zpatm(2,jl)
-
-               ! Computation of concentration at equilibrium : in picomol/l
-               ! coefficient for solubility for CFC-11/12 in  mol/l/atm
-               IF( tmask(ji,jj,1) .GE. 0.5 ) THEN
-                  ztap  = ( tsn(ji,jj,1,jp_tem) + 273.16 ) * 0.01
-                  zdtap = sob(1,jl) + ztap * ( sob(2,jl) + ztap * sob(3,jl) ) 
-                  zsol  =  EXP( soa(1,jl) + soa(2,jl) / ztap + soa(3,jl) * LOG( ztap )   &
-                     &                    + soa(4,jl) * ztap * ztap + tsn(ji,jj,1,jp_sal) * zdtap ) 
-               ELSE
-                  zsol  = 0.e0
-               ENDIF
-               ! conversion from mol/l/atm to mol/m3/atm and from mol/m3/atm to mol/m3/pptv    
-               zsol = xconv4 * xconv3 * zsol * tmask(ji,jj,1)  
-               ! concentration at equilibrium
-               zca_cfc = xconv1 * zpp_cfc * zsol * tmask(ji,jj,1)             
-  
-               ! Computation of speed transfert
-               !    Schmidt number revised in Wanninkhof (2014)
-               zt1  = tsn(ji,jj,1,jp_tem)
-               zt2  = zt1 * zt1 
-               zt3  = zt1 * zt2
-               zt4  = zt2 * zt2
-               zsch = sca(1,jl) + sca(2,jl) * zt1 + sca(3,jl) * zt2 + sca(4,jl) * zt3 + sca(5,jl) * zt4
-
-               !    speed transfert : formulae revised in Wanninkhof (2014)
-               zv2     = wndm(ji,jj) * wndm(ji,jj)
-               zsch    = zsch / 660.
-               zak_cfc = ( 0.251 * xconv2 * zv2 / SQRT(zsch) ) * tmask(ji,jj,1)
-
-               ! Input function  : speed *( conc. at equil - concen at surface )
-               ! trn in pico-mol/l idem qtr; ak in en m/a
-               qtr_cfc(ji,jj,jl) = -zak_cfc * ( trb(ji,jj,1,jn) - zca_cfc )   &
-                  &                         * tmask(ji,jj,1) * ( 1. - fr_i(ji,jj) )
-               ! Add the surface flux to the trend
-               tra(ji,jj,1,jn) = tra(ji,jj,1,jn) + qtr_cfc(ji,jj,jl) / e3t_n(ji,jj,1) 
-
-               ! cumulation of surface flux at each time step
-               qint_cfc(ji,jj,jl) = qint_cfc(ji,jj,jl) + qtr_cfc(ji,jj,jl) * rdt
-               !                                               !----------------!
-            END DO                                             !  end i-j loop  !
-         END DO                                                !----------------!
+            ! space interpolation
+            zpp_cfc  =       xphem(ji,jj)   * zpatm(1,jl)   &
+               &     + ( 1.- xphem(ji,jj) ) * zpatm(2,jl)
+
+            ! Computation of concentration at equilibrium : in picomol/l
+            ! coefficient for solubility for CFC-11/12 in  mol/l/atm
+            IF( tmask(ji,jj,1) .GE. 0.5 ) THEN
+               ztap  = ( ts(ji,jj,1,jp_tem,Kmm) + 273.16 ) * 0.01
+               zdtap = sob(1,jl) + ztap * ( sob(2,jl) + ztap * sob(3,jl) ) 
+               zsol  =  EXP( soa(1,jl) + soa(2,jl) / ztap + soa(3,jl) * LOG( ztap )   &
+                  &                    + soa(4,jl) * ztap * ztap + ts(ji,jj,1,jp_sal,Kmm) * zdtap ) 
+            ELSE
+               zsol  = 0.e0
+            ENDIF
+            ! conversion from mol/l/atm to mol/m3/atm and from mol/m3/atm to mol/m3/pptv    
+            zsol = xconv4 * xconv3 * zsol * tmask(ji,jj,1)  
+            ! concentration at equilibrium
+            zca_cfc = xconv1 * zpp_cfc * zsol * tmask(ji,jj,1)             
+            ! Computation of speed transfert
+            !    Schmidt number revised in Wanninkhof (2014)
+            zt1  = ts(ji,jj,1,jp_tem,Kmm)
+            zt2  = zt1 * zt1 
+            zt3  = zt1 * zt2
+            zt4  = zt2 * zt2
+            zsch = sca(1,jl) + sca(2,jl) * zt1 + sca(3,jl) * zt2 + sca(4,jl) * zt3 + sca(5,jl) * zt4
+
+            !    speed transfert : formulae revised in Wanninkhof (2014)
+            zv2     = wndm(ji,jj) * wndm(ji,jj)
+            zsch    = zsch / 660.
+            zak_cfc = ( 0.251 * xconv2 * zv2 / SQRT(zsch) ) * tmask(ji,jj,1)
+
+            ! Input function  : speed *( conc. at equil - concen at surface )
+            ! tr(:,:,:,:,Kmm) in pico-mol/l idem qtr; ak in en m/a
+            qtr_cfc(ji,jj,jl) = -zak_cfc * ( tr(ji,jj,1,jn,Kbb) - zca_cfc )   &
+               &                         * tmask(ji,jj,1) * ( 1. - fr_i(ji,jj) )
+            ! Add the surface flux to the trend
+            tr(ji,jj,1,jn,Krhs) = tr(ji,jj,1,jn,Krhs) + qtr_cfc(ji,jj,jl) / e3t(ji,jj,1,Kmm) 
+
+            ! cumulation of surface flux at each time step
+            qint_cfc(ji,jj,jl) = qint_cfc(ji,jj,jl) + qtr_cfc(ji,jj,jl) * rn_Dt
+            !                                               !----------------!
+         END_2D
          !                                                  !----------------!
       END DO                                                !  end CFC loop  !
@@ -191,5 +195,5 @@
       IF( l_trdtrc ) THEN
           DO jn = jp_cfc0, jp_cfc1
-            CALL trd_trc( tra(:,:,:,jn), jn, jptra_sms, kt )   ! save trends
+            CALL trd_trc( tr(:,:,:,jn,Krhs), jn, jptra_sms, kt, Kmm )   ! save trends
           END DO
       END IF
Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcwri_cfc.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcwri_cfc.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/CFC/trcwri_cfc.F90	(revision 12928)
@@ -20,5 +20,5 @@
 CONTAINS
 
-   SUBROUTINE trc_wri_cfc
+   SUBROUTINE trc_wri_cfc( Kmm )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE trc_wri_trc  ***
@@ -26,4 +26,5 @@
       !! ** Purpose :   output passive tracers fields 
       !!---------------------------------------------------------------------
+      INTEGER, INTENT(in)  :: Kmm   ! time level indices
       CHARACTER (len=20)   :: cltra
       INTEGER              :: jn
@@ -34,5 +35,5 @@
       DO jn = jp_cfc0, jp_cfc1
          cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
-         CALL iom_put( cltra, trn(:,:,:,jn) )
+         CALL iom_put( cltra, tr(:,:,:,jn,Kmm) )
       END DO
       !
Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/MY_TRC/trcini_my_trc.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/MY_TRC/trcini_my_trc.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/MY_TRC/trcini_my_trc.F90	(revision 12928)
@@ -28,5 +28,5 @@
 CONTAINS
 
-   SUBROUTINE trc_ini_my_trc
+   SUBROUTINE trc_ini_my_trc( Kmm )
       !!----------------------------------------------------------------------
       !!                     ***  trc_ini_my_trc  ***  
@@ -36,4 +36,5 @@
       !! ** Method  : - Read the namcfc namelist and check the parameter values
       !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   Kmm  ! time level indices
       !
       CALL trc_nam_my_trc
@@ -50,5 +51,5 @@
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
       
-      IF( .NOT. ln_rsttr ) trn(:,:,:,jp_myt0:jp_myt1) = 1.
+      IF( .NOT. ln_rsttr ) tr(:,:,:,jp_myt0:jp_myt1,Kmm) = 1.
       !
    END SUBROUTINE trc_ini_my_trc
Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/MY_TRC/trcsms_my_trc.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/MY_TRC/trcsms_my_trc.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/MY_TRC/trcsms_my_trc.F90	(revision 12928)
@@ -15,5 +15,4 @@
    USE trd_oce
    USE trdtrc
-   USE trcbc, only : trc_bc
 
    IMPLICIT NONE
@@ -32,5 +31,5 @@
 CONTAINS
 
-   SUBROUTINE trc_sms_my_trc( kt )
+   SUBROUTINE trc_sms_my_trc( kt, Kbb, Kmm, Krhs )
       !!----------------------------------------------------------------------
       !!                     ***  trc_sms_my_trc  ***
@@ -42,4 +41,5 @@
       !
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      INTEGER, INTENT(in) ::   Kbb, Kmm, Krhs  ! time level indices
       INTEGER ::   jn   ! dummy loop index
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: ztrmyt
@@ -54,6 +54,4 @@
       IF( l_trdtrc )  ALLOCATE( ztrmyt(jpi,jpj,jpk) )
 
-      CALL trc_bc ( kt )       ! tracers: surface and lateral Boundary Conditions
-
       ! add here the call to BGC model
 
@@ -61,6 +59,6 @@
       IF( l_trdtrc ) THEN
           DO jn = jp_myt0, jp_myt1
-            ztrmyt(:,:,:) = tra(:,:,:,jn)
-            CALL trd_trc( ztrmyt, jn, jptra_sms, kt )   ! save trends
+            ztrmyt(:,:,:) = tr(:,:,:,jn,Krhs)
+            CALL trd_trc( ztrmyt, jn, jptra_sms, kt, Kmm )   ! save trends
           END DO
           DEALLOCATE( ztrmyt )
Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/MY_TRC/trcwri_my_trc.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/MY_TRC/trcwri_my_trc.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/TOP/MY_TRC/trcwri_my_trc.F90	(revision 12928)
@@ -25,5 +25,5 @@
 CONTAINS
 
-   SUBROUTINE trc_wri_my_trc
+   SUBROUTINE trc_wri_my_trc( Kmm )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE trc_wri_trc  ***
@@ -31,4 +31,5 @@
       !! ** Purpose :   output passive tracers fields 
       !!---------------------------------------------------------------------
+      INTEGER, INTENT(in)  :: Kmm   ! time level indices
       CHARACTER (len=20)   :: cltra
       INTEGER              :: jn
@@ -39,5 +40,5 @@
       DO jn = jp_myt0, jp_myt1
          cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
-         CALL iom_put( cltra, trn(:,:,:,jn) )
+         CALL iom_put( cltra, tr(:,:,:,jn,Kmm) )
       END DO
       !
